// transform where construct to where statement 
#include        <stdio.h>
#include        <string.h>
#include        "compilerApi.h"
#include        "ext_func.h"
#define 	IDSTR	"A"
int     whereconstruct_to_where(SgStatement *,SgStatement *);
 //change the where construct to where statement

SgVariableSymb  *get_temp_variable(SgStatement *,SgType *,char *);
//return a temporary variable and declare it in given statement

SgVariableSymb	*get_temp_index(int,SgStatement *,char *);
//return an index variable and declare it in given statement
//int variable is the digit used in the index variable. 

int align_where_condition(SgStatement *,SgSymbol *, SgSymbol *);
// align where condition temporary variable to assign lhs variable

void	init_temp_index(SgStatement *);
//initialize index variable

int	isBinaryOp(SgExpression *);
//judge if given expression have left hand and right hand

int is_function(SgExpression *);
//if the expression is any form of function call or function reference or user defined operator 

int 	if_trans(SgStatement *);
//if we need to change the statement

SgType * array_exp_type(SgExpression * exp);
// get the exp's type .

#include "consw.h"

int     whereconstruct_to_where(SgStatement *hedr_stmt,SgStatement *current)
{
        SgAssignStmt    *aassign;
	SgStatement	*statement,*next_stmt,*temp_stmt,*control_parent;
	SgWhereStmt	*awherestmt;
        SgVarRefExp     *index_exp;
        SgExpression    *index_trip;
        SgVariableSymb  *temp;
        SgExpression    *lhs_res,*rhs_res,*mask_res;
        SgExpression    *lhs,*rhs,*cond;
	int		index_var=0;
	SgSubscriptExp	*subscript;
	SgType		*returntype;
	SgType		*type=SgTypeBool();
	SgStatement	*decl_stmt,*last_decl;
        SgVariableSymb  *var_sym;
	int 		i=0;
	SgVarRefExp	*var_sym_exp;
	SgExpression	*false_exp,*temp_mask_exp;
	SgSymbol	*align_target=NULL;
//get the control parent statement.
	control_parent=current->controlParent();
//get mask_expr of the where statement
        cond=current->expr(0);
//get the left Hand side of assign statement
        lhs=(current->childList1(0))->expr(0);
//get array type of given expression
	returntype=array_exp_type(lhs);
	((SgArrayType*)returntype)->setBaseType(*type);    // set as T_BOOL
//get temporary variable of given type
        var_sym=get_temp_variable(hedr_stmt,returntype,IDSTR);
	var_sym_exp=new SgVarRefExp(var_sym);
	temp_mask_exp=var_sym_exp;
// make the stmt
        decl_stmt=var_sym->makeVarDeclStmt();
//get last declare statement
        last_decl=hedr_stmt->lastDeclaration();
//declare the symbol
        last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
//create mask expr assign  statement
        aassign= new  SgAssignStmt(*temp_mask_exp,*cond->copyPtr());
//insert the mask assign statement
//        current->lexPrev()->insertStmtAfter(*aassign,*control_parent);
        current->insertStmtBefore(*aassign,*control_parent);

//now split the where construct to where statement
//first split the true block
	statement=current->childList1(i++);
	while ( (statement!=NULL) && (statement->variant() != CONTROL_END)){
                temp_stmt=statement->copyPtr();
		awherestmt=new SgWhereStmt(*temp_mask_exp,*temp_stmt);
	        current->insertStmtBefore(*awherestmt,*control_parent);
                //current->lexPrev()->insertStmtAfter(*awherestmt,*control_parent);

		if ( align_target == NULL && statement->variant() == ASSIGN_STAT)
		{
			SgExpression *lhs = statement->expr(0);
			if (lhs->variant()== VAR_REF)
				align_target = lhs->symbol();
		}

		statement=current->childList1(i++);
                //statement=current->nextInChildList();
                //statement=statement->lexNext();

                var_sym_exp=new SgVarRefExp(var_sym);
                temp_mask_exp=var_sym_exp;
	}

//now split the FALSE block
	i=0;
	//false_exp=&((*temp_mask_exp) ^= (*temp_mask_exp));
        false_exp=&(SgNotOp(*temp_mask_exp));
	statement=current->childList2(i++);
        while ( (statement!=NULL) && (statement->variant() != CONTROL_END) ){
                temp_stmt=statement->copyPtr();
		//statement=statement->copyPtr();
                awherestmt=new SgWhereStmt(*false_exp,*temp_stmt);
                current->insertStmtBefore(*awherestmt,*control_parent);

 //               current->lexPrev()->insertStmtAfter(*awherestmt,*control_parent);

                statement=current->childList2(i++);  
                //statement=current->nextInChildList();
	        var_sym_exp=new SgVarRefExp(var_sym);
	       	temp_mask_exp=var_sym_exp;
		false_exp=&(SgNotOp(*temp_mask_exp));

	
        }

	// align mask temp variable to assign lhs symbol
	if (align_target)
	{
		align_where_condition(hedr_stmt , var_sym , align_target);
	}

//delete the original where construct
        current->deleteStmt();
        return  0;

}


/*
void align_where_condition(SgStatement *hedr_stmt,SgSymbol *tmp, SgSymbol *target)
{
	int dim=0;
	SgArrayType *type = isSgArrayType(target->type());
	ASSERT (type != NULL);
	dim=type->dimension();

	SgExpression *expr_list=NULL;
	for (int i=0; i<dim ; i++)
	{
		char str[5];
		sprintf(str,"%s%d","i",i);
		SgSymbol *dummy = hedr_stmt->GetSymbolInScope(hedr_stmt,str);
		SgVarRefExp *ref = new SgVarRefExp(dummy);
		expr_list = new SgExpression(EXPR_LIST,ref,expr_list,NULL);
	}
	// scalar not considered
	SgExpression *arrayref = new SgArrayRefExp(*target,*expr_list);
	SgExpression *align_with = new SgExpression(ALIGN_WITH_OP,NULL,arrayref,NULL);
	SgExpression *align_op = new SgExpression(ALIGN_OP,expr_list->copyPtr(),align_with,NULL);
	expr_list = new SgExpression(EXPR_LIST , align_op ,NULL,NULL);

	SgExpression *varref = new SgVarRefExp(tmp);
	SgExpression *var_list = new SgExpression(EXPR_LIST , varref ,NULL,NULL);

	SgStatement *align_decl=new SgStatement(ALIGN_DECL,NULL,NULL,var_list,NULL,expr_list);
	SgStatement *decl = tmp->declareInStmt(hedr_stmt);
	if (decl==NULL) decl=hedr_stmt->firstStmtForDeclaration();
       	decl->insertStmtAfter(*align_decl,*hedr_stmt);
}
*/

// 1 means suceed.
int align_where_condition(SgStatement *hedr_stmt,SgSymbol *tmp, SgSymbol *align_target)
{
      int org_numberOfChildren=hedr_stmt->numberOfChildrenList1();
      int i; 

      for (i=0; i<org_numberOfChildren; i++)
      {
	SgStatement *s=hedr_stmt->childList1(i);

	switch (s->variant() ) 
	{
  	case COMBINED_DIRECTIVE_DECL: {
		SgExpression *exprlist = s->expr(0);
		if (exprlist->IsSymbolInExpression(*align_target) )
		{
			SgExpression *newexp = new SgVarRefExp(tmp);
			SgExpression *newlist = new SgExpression(EXPR_LIST,newexp,exprlist,NULL);
			s->setExpression(0,newlist);
			return 1;
		}
		break;
    	}
	case ALIGN_DECL:
	case DISTRIBUTE_DECL: {
		SgExpression *exprlist = s->expr(0);
		if (exprlist->IsSymbolInExpression(*align_target) )
		{
			SgStatement *news = s->copyPtr();
			SgExpression *newlist = news->expr(0);
			SgExpression *newexp = new SgVarRefExp(tmp);
			newlist->setLhs(*newexp);
			SgStatement *decl = tmp->declareInStmt(hedr_stmt);
			if (decl==NULL) decl=hedr_stmt->firstStmtForDeclaration();
       			decl->insertStmtAfter(*news,*hedr_stmt);
			return 1;
		}
		break;
    	}
  	}	// end of switch
     }
     return 0;
}


